/* This file is part of the Java Pathfinder (JPF) distribution from
 * NASA Ames Research Center. See file LICENSE for usage terms.
 * (C) 1999,2003 NASA Ames Research Center
 */

/* Author: Masoud Mansouri-Samani
 * Date: 15 Sept 2003
 */

package DiningPhilosophers;

public class Fork {
  private boolean free;
  private int num;

  Fork(int n) {
    free = true;
    this.num = n;
  }

  synchronized void grab(int phil) {
    while (!free) {
      try {
        wait();
      } catch (InterruptedException e) {
        System.out.println(e);
      }
    }
    free = false;
    System.out.println(phil+" Grabbed fork#: "+num);
  }

  synchronized void release(int phil) {
    free = true;
    notify();
    System.out.println(phil+" Released fork#: "+num);
  }
}
